%Example of user input MATLAB file for MCR post processing
%filename = ['savedData',sprintf('%03d', imcr),'.mat'];
% filename = sprintf('BaselineHydData%03d.mat', imcr);
filename = sprintf('w%01dP3A3.mat', imcr);

t1=simu.rampTime;             %time after ramp
t2=simu.endTime;             %end of analysis

V = InVel((t1/simu.dt):(t2/simu.dt));
F = -SimTension((t1/simu.dt):(t2/simu.dt));
F = max(F,0);
 
mcr.AvgProduced(imcr) = mean(SimQp((t1/simu.dt):(t2/simu.dt)))*15850.323;   %store average permeate production [gpm]
mcr.AvgFeed(imcr) = mean(SimQfeed((t1/simu.dt):(t2/simu.dt)))*15850.323;    %store average feed flow [gpm]
mcr.AvgPumpQ(imcr) = mean(SimQpump((t1/simu.dt):(t2/simu.dt)))*15850.323;    %store average pump output flow [gpm]
mcr.AvgPress(imcr) = mean(SimPfeed((t1/simu.dt):(t2/simu.dt)))*0.000145038; %store average feed pressure [psi]
mcr.AvgMechPower(imcr) = mean(F.*V);                                        %Average mechanical power input [Watts]
mcr.AvgPumpPower(imcr) = mean(SimQpump((t1/simu.dt):(t2/simu.dt)))*mean(SimPpump((t1/simu.dt):(t2/simu.dt)));         %Average Hydraulic power at pump output [Watts]
mcr.AvgROPower(imcr) = mean(SimQfeed((t1/simu.dt):(t2/simu.dt)))*mean(SimPfeed((t1/simu.dt):(t2/simu.dt)));           %Average Hydraulic power at RO Feed [Watts]

mcr.time = output.bodies.time';                                        %Store Time array [s]
mcr.watersurface = output.wave.elevation';                             %Store Wave Elevation [m]
mcr.WECheave = output.bodies.position(:,3)';                           %Store WEC heave position [m]   
mcr.velheave = InVel';                                                 %store input velocity at winch [m/s]winchtension(imcr) = SimTension*0.224809';                               %store tension on winch cable [lbf]
mcr.winchpos = SimPos';                                                %store winch position [rad]
mcr.winchvel = SimWinw;                                                %store winch velocity [rad/s]
mcr.winchten = SimTension*0.224809';                                   %store winch tension [lbf] 
mcr.SimQpump = SimQpump*15850.323';                                    %store pump flow [gpm]
mcr.SimPpump = SimPpump*0.000145038';                                  %store pump output pressure [psi]
mcr.SimPumpw = SimPumpw;                                               %store pump velocity [rad/s]
mcr.SimQfeed = SimQfeed*15850.323';                                    %store RO feed flow [gpm]
mcr.SimPfeed = SimPfeed*0.000145038';                                  %store RO feed pressure [psi]
mcr.SimQp = SimQp*15850.323';                                          %store RO permeate flow [gpm]

save (filename, 'mcr','output','waves');

if imcr == length(mcr.cases);
    H = mcr.cases(:,1);
    T = mcr.cases(:,2);
 

% figure;
% Pumpmat=reshape(mcr.AvgPumpQ,[l_waveperiod,l_waveheight])'
% heatmap(Pumpmat,XData=unique(T),YData=unique(H))'
% xlabel('Tp [s]')
% ylabel('Hs [m]')
% title('Average Pump Output [gpm]')
% 
% figure;
% FeedQmat=reshape(mcr.AvgFeed,[l_waveperiod,l_waveheight])'
% heatmap(FeedQmat,XData=unique(T),YData=unique(H))'
% xlabel('Tp [s]')
% ylabel('Hs [m]')
% title('Average RO Feed Flow [gpm]')

figure;
pressmat=reshape(mcr.AvgPress,[l_waveperiod,l_waveheight])'
heatmap(pressmat,XData=unique(T),YData=unique(H))
xlabel('Tp [s]')
ylabel('Hs [m]')
title('Average Feed Pressure [psi]')

figure;
watmat=reshape(mcr.AvgProduced,[l_waveperiod,l_waveheight])'
heatmap(watmat,XData=unique(T),YData=unique(H))'
xlabel('Tp [s]')
ylabel('Hs [m]')
title('Average Water Production [gpm]')


% figure;
% powermat=reshape(mcr.AvgMechPower,[l_waveperiod,l_waveheight])'
% heatmap(powermat,XData=unique(T),YData=unique(H))
% xlabel('Tp [s]')
% ylabel('Hs [m]')
% title('Average Mechanical Power input [Watts]')
% 
% figure;
% powermat2=reshape(mcr.AvgPumpPower,[l_waveperiod,l_waveheight])'
% heatmap(powermat2,XData=unique(T),YData=unique(H))
% xlabel('Tp [s]')
% ylabel('Hs [m]')
% title('Average Hydraulic Power at Pump [Watts]')
% 
% figure;
% powermat3=reshape(mcr.AvgROPower,[l_waveperiod,l_waveheight])'
% heatmap(powermat3,XData=unique(T),YData=unique(H))
% xlabel('Tp [s]')
% ylabel('Hs [m]')
% title('Average Hydraulic Power RO Input [Watts]')

end




